<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:h="http://www.schema-library.org/input-schema-and-its-dependency-hierarchy"
                exclude-result-prefixes="#all"
                version="2.0">
    
    <!-- 
        Recall that I added to the
        single file a schema that contains a simpleType for each XSD 
        datatype. This program inserts into all the other
        schemas an import element - import the datatypes schema.
        
        Author: Roger L. Costello
    -->
    
    <xsl:function name="h:add-import-xsd-datatypes-schema" as="document-node()">
        <xsl:param name="schemas" as="document-node()" />
        
        <xsl:variable name="updated-schemas">
            <xsl:apply-templates select="$schemas/schemas" mode="add-import-xsd-datatypes-schema"/>
        </xsl:variable>
        
        <xsl:sequence select="$updated-schemas" />
        
    </xsl:function>
    
    <xsl:template match="@* | node()" mode="add-import-xsd-datatypes-schema">
        
        <xsl:copy>
            <xsl:apply-templates select="@*"  mode="add-import-xsd-datatypes-schema" />
            <xsl:apply-templates  mode="add-import-xsd-datatypes-schema" />
        </xsl:copy>
        
    </xsl:template>
    
    <xsl:template match="xs:schema[not(ends-with(@xml:base, 'schema-data-types.xsd'))]" mode="add-import-xsd-datatypes-schema">
        
        <xsl:variable name="xsd-id" select="../xs:schema[ends-with(@xml:base, 'schema-data-types.xsd')]/@_id" />
        
        <xsl:for-each select=".">
            <xsl:copy>
                <xsl:apply-templates select="@*"  mode="add-import-xsd-datatypes-schema" />
                <xsl:text>
                    
                </xsl:text>
                <xs:import namespace="http://www.w3.org/2001/XMLSchema" 
                           schemaLocation="schema-data-types.xsd"
                           idref="{$xsd-id}" />
                <xsl:apply-templates  mode="add-import-xsd-datatypes-schema" />
            </xsl:copy>
        </xsl:for-each>
        
    </xsl:template>
    
</xsl:stylesheet>